"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Environment = exports.TunnelOptions = void 0;
const tunnel = require('tunnel-ssh');
class TunnelOptions {
}
exports.TunnelOptions = TunnelOptions;
class Environment {
    static getAwsRegion() {
        return process.env.AWS_REGION || this.DEFAULT_REGION;
    }
    static getEnvironment() {
        return this.CURRENT_ENVIRONMENT;
    }
    static isLocal() {
        return !this.PRODUCTION.includes(this.CURRENT_ENVIRONMENT) && this.CURRENT_ENVIRONMENT !== this.DEVELOP;
    }
    static isRemote() {
        return this.CURRENT_ENVIRONMENT === this.DEVELOP || this.PRODUCTION.includes(this.CURRENT_ENVIRONMENT);
    }
    static isDevelop() {
        return this.CURRENT_ENVIRONMENT === this.DEVELOP;
    }
    static isTest() {
        return this.CURRENT_ENVIRONMENT === this.TEST;
    }
    static isProduction() {
        return this.PRODUCTION.includes(this.CURRENT_ENVIRONMENT);
    }
    static configureTunnel(sshTunnelConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            yield new Promise(function (resolve, reject) {
                tunnel(sshTunnelConfig, (error, server) => {
                    if (error) {
                        console.log('Error on tunnel configuration: ', error);
                        reject(error);
                    }
                    resolve(server);
                });
            });
        });
    }
}
exports.Environment = Environment;
Environment.CURRENT_ENVIRONMENT = process.env.APIPASS_ENVIRONMENT;
Environment.PRODUCTION = ['prd', 'prod', 'nstech'];
Environment.DEVELOP = 'develop';
Environment.TEST = 'test';
Environment.DEFAULT_REGION = 'us-east-1';
//# sourceMappingURL=environment.js.map